// demo_mfc.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "hts_view.h"

#include "demo_mfc.h"

#include "mainfrm.h"
#include "demo_doc.h"
#include "demo_vw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoApp

BEGIN_MESSAGE_MAP(CDemoApp, CWinApp)
        //{{AFX_MSG_MAP(CDemoApp)
        ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
        ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
        //}}AFX_MSG_MAP
        // Standard file based document commands
        ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
        ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
        // Standard print setup command
        ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoApp construction

CDemoApp::CDemoApp()
{
    // variables to show a ter buffer in the About dialog box
    hTerBuffer=NULL;    // ter io buffer
    TerBufferLen=0;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDemoApp object

CDemoApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CDemoApp initialization

BOOL CDemoApp::InitInstance()
{
        // Standard initialization
        // If you are not using these features and wish to reduce the size
        //  of your final executable, you should remove from the following
        //  the specific initialization routines you do not need.

        SetDialogBkColor();        // set dialog background color to gray
        LoadStdProfileSettings();  // Load standard INI file options (including MRU)

        // Register the application's document templates.  Document templates
        //  serve as the connection between documents, frame windows and views.

        AddDocTemplate(new CMultiDocTemplate(IDR_FILETYPE,
                        RUNTIME_CLASS(CDemoDoc),
                        RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
                        RUNTIME_CLASS(CDemoView)));

        // create main MDI Frame window
        CMainFrame* pMainFrame = new CMainFrame;
        if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
                return FALSE;
        pMainFrame->ShowWindow(m_nCmdShow);
        pMainFrame->UpdateWindow();
        m_pMainWnd = pMainFrame;

        // enable file manager drag/drop and DDE Execute open
        m_pMainWnd->DragAcceptFiles();
        EnableShellOpen();
        RegisterShellFileTypes();

        // simple command line parsing
        if (m_lpCmdLine[0] == '\0')
        {
                // create a new (empty) document
                OnFileNew();
        }
        else if ((m_lpCmdLine[0] == '-' || m_lpCmdLine[0] == '/') &&
                (m_lpCmdLine[1] == 'e' || m_lpCmdLine[1] == 'E'))
        {
                // program launched embedded - wait for DDE or OLE open
        }
        else
        {
                // open an existing document
                OpenDocumentFile(m_lpCmdLine);
        }

        return TRUE;
}

void CDemoApp::OnFilePrintSetup() 
{
    CPrintDialog pd(TRUE);         // temporary copy of 
    PRINTDLG pdlg;
    CString PortName,DeviceName,DriverName;

    CWinApp::DoPrintDialog(&pd);   // a copy of pd is saved with CWinApp
    
    // inform TER of the current printer selection
    pdlg=pd.m_pd;
    if (pdlg.hDevNames) {
       BYTE device[60],driver[30],port[30];
       POSITION pos1;

       PortName=pd.GetPortName();
       DriverName=pd.GetDriverName();
       DeviceName=pd.GetDeviceName();
       lstrcpy((LPSTR)device,DeviceName);
       lstrcpy((LPSTR)driver,DriverName);
       lstrcpy((LPSTR)port,PortName);

       // Tell all TER windows about the new printer selection
       #if _MFC_VER >= 0x0400
          pos1 = GetFirstDocTemplatePosition();   // get the position of the first document template
       #else
          pos1 = m_templateList.GetHeadPosition(); // valid before VC 4.0
       #endif

       while (pos1)        // loop through each document template
       {
          // get the template at the current position and advance the template position
          #if _MFC_VER >= 0x0400
             CDocTemplate* pTemplate = GetNextDocTemplate(pos1);
          #else
             CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetNext(pos1);  // valid before VC4.0
          #endif

          // get the position of the first document for the current template
          POSITION pos2 = pTemplate->GetFirstDocPosition();

          while (pos2)     // loop through each document for the template
          {
              CDocument * pDocument;

              // get the document at the current position and increment the position
              if ((pDocument=pTemplate->GetNextDoc(pos2)) != NULL)  {
                 // get the position of the first (and only) view for this document
                 POSITION pos3=pDocument->GetFirstViewPosition();
                 CTerView *view = (CTerView *) pDocument->GetNextView(pos3); // get our view

                 // update printer selection for this view
                 ::TerSetPrinter(view->m_hWnd,device,driver,port,pdlg.hDevMode);
              }
          }
       }
    }
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CWnd *m_pTer;

        CAboutDlg();

// Dialog Data
        //{{AFX_DATA(CAboutDlg)
        enum { IDD = IDD_ABOUTBOX };
        //}}AFX_DATA

// Implementation
protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support
        
        void         TerDataExchange(BOOL);                     // data io with the ter window

        BOOL OnInitDialog();
        
        //{{AFX_MSG(CAboutDlg)
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
        //{{AFX_MSG_MAP(CAboutDlg)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
        //{{AFX_DATA_INIT(CAboutDlg)
        //}}AFX_DATA_INIT
}

BOOL CAboutDlg::OnInitDialog()
{
        m_pTer=GetDlgItem(IDC_TER1);
        HtsInitialize(m_pTer->m_hWnd,m_hWnd);

        CDialog::OnInitDialog();       // do data exchange etc

        return TRUE;
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP

    TerDataExchange(pDX->m_bSaveAndValidate);
}

//  data io from the TER control
void CAboutDlg::TerDataExchange(BOOL save)
{
    if (!save) HtsRead(m_pTer->m_hWnd,HTML_FILE,(LPBYTE)"demo.htm",NULL,0,(LPBYTE)"");
}

// App command to run the dialog
void CDemoApp::OnAppAbout()
{
        CAboutDlg aboutDlg;
        aboutDlg.DoModal();
}

